<?php
require 'db1.php'; // Incluye el archivo de conexión a la base de datos


date_default_timezone_set('America/Guayaquil');
// Agregar los encabezados para desactivar la cach��
header("Cache-Control: no-cache, no-store, must-revalidate");
header("Pragma: no-cache");
header("Expires: 0");

// Endpoint para obtener datos de la tabla conario
if ($_SERVER['REQUEST_METHOD'] === 'GET') {

    if (isset($_GET['vic_id'])) {
        $tipoObraId = $_GET['vic_id'];

        $query = "SELECT * FROM vivienda_conjunto WHERE vic_id = ?";
        $stmt = $conn->prepare($query);
        $stmt->execute([$tipoObraId]);

        $data = $stmt->fetch(PDO::FETCH_ASSOC);

        if ($data) {
            echo json_encode($data);
        } else {
            echo json_encode(array("message" => "No se encontró ningúna Vivienda"));
        }
    } else if (isset($_GET['obr_id'])) {
        $tipoObraId = $_GET['obr_id'];

        $query = "SELECT * FROM vivienda_conjunto WHERE obr_id = ?";
        $stmt = $conn->prepare($query);
        $stmt->execute([$tipoObraId]);

        $data = $stmt->fetchAll(PDO::FETCH_ASSOC);

        if ($data) {
            echo json_encode($data);
        } else {
            echo json_encode(array("message" => "No se encontró ningúna Vivienda"));
        }
    } else {
        $query = "SELECT * FROM vivienda_conjunto";
        $stmt = $conn->prepare($query);
        $stmt->execute();
        
        $data = $stmt->fetchAll(PDO::FETCH_ASSOC);
        
        echo json_encode($data);
    }
}


// Endpoint para insertar datos en la tabla conario
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    try {
        $data = json_decode(file_get_contents('php://input'), true);

        $prq_id = $data['prq_id'];
        $vic_direccion = $data['vic_direccion'];
        $vic_porcentaje_avance = $data['vic_porcentaje_avance'];
        $vic_fecha_termino_hito_1 = $data['vic_fecha_termino_hito_1'];
        $vic_fecha_termino_hito_2 = $data['vic_fecha_termino_hito_2'];
        $vic_fecha_termino_hito_3 = $data['vic_fecha_termino_hito_3'];
        $vic_fecha_termino_hito_4 = $data['vic_fecha_termino_hito_4'];
        $vic_fecha_termino_hito_5 = $data['vic_fecha_termino_hito_5'];
        $vic_fecha_termino_hito_6 = $data['vic_fecha_termino_hito_6'];
        $vic_fecha_termino_hito_7 = $data['vic_fecha_termino_hito_7'];
        $vic_fecha_termino_hito_8 = $data['vic_fecha_termino_hito_8'];
        $obr_id = $data['obr_id'];
        $vic_nombre = $data['vic_nombre'];
        $vic_fecha_creacion = date('Y-m-d H:i:s');
        $vic_fecha_modificacion = date('Y-m-d H:i:s');
        $vic_estado = 1;

        $query = "INSERT INTO vivienda_conjunto (
            prq_id,
            vic_direccion,
            vic_porcentaje_avance,
            vic_fecha_termino_hito_1,
            vic_fecha_termino_hito_2,
            vic_fecha_termino_hito_3,
            vic_fecha_termino_hito_4,
            vic_fecha_termino_hito_5,
            vic_fecha_termino_hito_6,
            vic_fecha_termino_hito_7,
            vic_fecha_termino_hito_8,
            obr_id,
            vic_nombre,
            vic_fecha_creacion,
            vic_fecha_modificacion,
            vic_estado
        ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

        $stmt = $conn->prepare($query);
        $stmt->execute([
            $prq_id,
            $vic_direccion,
            $vic_porcentaje_avance,
            $vic_fecha_termino_hito_1,
            $vic_fecha_termino_hito_2,
            $vic_fecha_termino_hito_3,
            $vic_fecha_termino_hito_4,
            $vic_fecha_termino_hito_5,
            $vic_fecha_termino_hito_6,
            $vic_fecha_termino_hito_7,
            $vic_fecha_termino_hito_8,
            $obr_id,
            $vic_nombre,
            $vic_fecha_creacion,
            $vic_fecha_modificacion,
            $vic_estado
        ]);

        $insertedId = $conn->lastInsertId();
          if ($stmt){
        echo json_encode(array("message" => "0", "inserted_id" => intval($insertedId)));
    } else {
        echo json_encode(array("inserted_id" => -2));
    }
    
} catch (PDOException $e) {
    if ($e->getCode() == 23000) {
        // Código 23000 indica una violación de integridad (clave duplicada)
        echo json_encode(array("message" => "Error: Se intentó ingresar una clave primaria ya existente", "inserted_id" => -3));
    } else {
        // Otro error, imprime el mensaje de la excepción
        echo json_encode(array("message" => "Error: " . $e->getMessage(), "inserted_id" => -2));
    }
}
}

// Endpoint para actualizar datos en la tabla persona
if ($_SERVER['REQUEST_METHOD'] === 'PUT') {
try {
    $data = json_decode(file_get_contents('php://input'), true);

    $vic_id = $data['vic_id'];

    $prq_id = $data['prq_id'];
    $vic_direccion = $data['vic_direccion'];
    $vic_porcentaje_avance = $data['vic_porcentaje_avance'];
    $vic_fecha_termino_hito_1 = $data['vic_fecha_termino_hito_1'];
    $vic_fecha_termino_hito_2 = $data['vic_fecha_termino_hito_2'];
    $vic_fecha_termino_hito_3 = $data['vic_fecha_termino_hito_3'];
    $vic_fecha_termino_hito_4 = $data['vic_fecha_termino_hito_4'];
    $vic_fecha_termino_hito_5 = $data['vic_fecha_termino_hito_5'];
    $vic_fecha_termino_hito_6 = $data['vic_fecha_termino_hito_6'];
    $vic_fecha_termino_hito_7 = $data['vic_fecha_termino_hito_7'];
    $vic_fecha_termino_hito_8 = $data['vic_fecha_termino_hito_8'];
    $obr_id = $data['obr_id'];
    $vic_nombre = $data['vic_nombre'];
    $vic_fecha_modificacion = date('Y-m-d H:i:s');
    $vic_estado = $data['vic_estado_registro'];

    $query = "UPDATE vivienda_conjunto SET
        prq_id = ?,
        vic_direccion = ?,
        vic_porcentaje_avance = ?,
        vic_fecha_termino_hito_1 = ?,
        vic_fecha_termino_hito_2 = ?,
        vic_fecha_termino_hito_3 = ?,
        vic_fecha_termino_hito_4 = ?,
        vic_fecha_termino_hito_5 = ?,
        vic_fecha_termino_hito_6 = ?,
        vic_fecha_termino_hito_7 = ?,
        vic_fecha_termino_hito_8 = ?,
        obr_id = ?,
        vic_nombre = ?,
        vic_fecha_modificacion = ?,
        vic_estado = ?
    WHERE vic_id = ?";

    $stmt = $conn->prepare($query);
    $stmt->execute([
        $prq_id,
        $vic_direccion,
        $vic_porcentaje_avance,
        $vic_fecha_termino_hito_1,
        $vic_fecha_termino_hito_2,
        $vic_fecha_termino_hito_3,
        $vic_fecha_termino_hito_4,
        $vic_fecha_termino_hito_5,
        $vic_fecha_termino_hito_6,
        $vic_fecha_termino_hito_7,
        $vic_fecha_termino_hito_8,
        $obr_id,
        $vic_nombre,
        $vic_fecha_modificacion,
        $vic_estado,
        $vic_id
    ]);

    if ($stmt) {
        echo json_encode(array("inserted_id" => 1));
    } else {
        echo json_encode(array("inserted_id" => -2));
    }
    
} catch (PDOException $e) {
     echo json_encode(array("message" => "Error: " . $e->getMessage(), "inserted_id" => -2));
    }
}


// Endpoint para eliminar un registro de la tabla persona
if ($_SERVER['REQUEST_METHOD'] === 'DELETE') {
try{
    $data = json_decode(file_get_contents('php://input'), true);

    $vic_id = $data['vic_id']; // ID de la vivienda conjunto a eliminar

    $query = "DELETE FROM vivienda_conjunto WHERE vic_id = ?";

    $stmt = $conn->prepare($query);
    if ($stmt->execute([$vic_id])) {
             echo json_encode(array("inserted_id" => 1));
    } else {
        echo json_encode(array("inserted_id" => -2));
    }
} catch (PDOException $e) {
     echo json_encode(array("message" => "Error: " . $e->getMessage(), "inserted_id" => -2));
    }

}

$conn = null;
?>